(function(angular, $, _) {

  angular.module('form_processor').controller('ActionDialogCtrl', function InputDialogCtrl($scope, dialogService, crmApi) {
    $scope.ts = CRM.ts(null);
    
    $scope.action = angular.copy($scope.model.action);
    $scope.model.context;
    
    $scope.locks = {name: true};
    $scope.isNameValid = false;
    
    $scope.$watch('action.name', function(newName, oldName) {
    	// Watch for changes in the name field
    	$scope.isNameValid = false;
    	if (newName) {
	      crmApi($scope.model.entity, 'validatename', {'name': newName,'id': $scope.action.id})
	      .then(function(data) {
	      	if (data.is_valid) {
	      		$scope.isNameValid = true;
	      	}
	      });
     }
    }, true);
    
    $scope.$watch('action.title', function(newTitle, oldTitle) {
    	// Watch for changes in the name field
    	if ($scope.locks.name && $scope.action.id <= 0) {
    		$scope.action.name = newTitle; 
        $scope.action.name = $scope.action.name.toLowerCase();
        $scope.action.name = $scope.action.name.replace(/[^a-zA-Z\d]/g, '_');
        $scope.action.name = $scope.action.name.replace(/_+n/g, '_');
    	}
    }, true);
    
    $scope.isValidName = function(name) {
    	return (!name) || name.match(/^[a-z0-9_]+$/) ? true : false;
    };
    
    $scope.saveClick = function() {
    	$scope.model.action = $scope.action;
    	dialogService.close('ActionDialog', $scope.model);
    };
		
		$scope.cancelClick = function() {
    	dialogService.cancel('ActionDialog');
    };
    
  });

})(angular, CRM.$, CRM._);
