(function(angular, $, _) {

  angular.module('form_processor').controller('InputDialogCtrl', function InputDialogCtrl($scope, dialogService, crmApi) {
    $scope.ts = CRM.ts(null);
    $scope.input = angular.copy($scope.model.input);
    $scope.locks = {name: true};
    $scope.isNameValid = false;
  	$scope.validators = CRM.form_processor.validators;
  	
  	if (!$scope.input.deletedValidators) {
  		$scope.input.deletedValidators = [];
  	}

    $scope.$watch('input.name', function(newName, oldName) {
      // Watch for changes in the name field
      $scope.isNameValid = false;
      if (newName) {
        crmApi($scope.model.entity, 'validatename', {'name': newName,'id': $scope.input.id})
          .then(function(data) {
            if (data.is_valid) {
              $scope.isNameValid = true;
            }
          });
      }
    }, true);

    $scope.$watch('input.title', function(newTitle, oldTitle) {
      // Watch for changes in the name field
      if ($scope.locks.name && $scope.input.id <= 0) {
        $scope.input.name = newTitle;
        $scope.input.name = $scope.input.name.toLowerCase();
        $scope.input.name = $scope.input.name.replace(/[^a-zA-Z\d]/g, '_');
        $scope.input.name = $scope.input.name.replace(/_+n/g, '_');
      }
    }, true);

    $scope.isValidName = function(name) {
      return (!name) || name.match(/^[a-z0-9_]+$/) ? true : false;
    };
    
    $scope.saveClick = function() {
    	$scope.model.input = $scope.input;
    	dialogService.close('InputDialog', $scope.model);
    };
		
		$scope.cancelClick = function() {			
    	dialogService.cancel('InputDialog');
    };
    
    $scope.addValidator = function(newValidator) {
    	if (!newValidator) {
    		return;
    	}
    	var validator = {
    		validator: angular.copy(newValidator),
    		configuration: {}
    	}; 
    	$scope.input.validators.push(validator);
    };
    
    $scope.removeValidator = function(validator) {
    	var index = $scope.input.validators.indexOf(validator);
    	if (index >= 0) {
    		$scope.input.deletedValidators.push(validator);
    		$scope.input.validators.splice(index, 1);
    	}
    };
    
  });

})(angular, CRM.$, CRM._);
